﻿Module Module1
    Delegate Function Dlg(Of VType)(ByVal V As VType) As VType

    Public Function ShowValue(Of VType)(ByVal V As VType) _
             As VType
        Dim V2 As VType = V
        Console.WriteLine(V)
        Return V2
    End Function

    Sub ShowMsg(ByVal M As Action(Of String))
        Call M("Test Message")
    End Sub

    Sub Show2(ByVal MessageText As String)
        Console.WriteLine(MessageText & " 2")
    End Sub

    Sub Main()
        Dim ShowInteger As Dlg(Of Integer) = AddressOf ShowValue(Of Integer)
        Dim X As Integer = ShowInteger(3)
        Dim ShowLong As Dlg(Of Long) = AddressOf ShowValue(Of Long)
        Dim Y As Long = ShowLong(1000000000000000000)
        Dim ShowStr As Dlg(Of String) = AddressOf ShowValue
        Dim S As String = ShowStr("Test")

        Dim IntDlg As Func(Of Integer, Integer) = AddressOf ShowValue
        X = IntDlg(3)
        Dim LongDlg As Func(Of Long, Long) = AddressOf ShowValue
        Y = LongDlg(1000000000000000000)
        Dim StrDlg As Func(Of String, String) = AddressOf ShowValue
        S = StrDlg("Test")

        ShowMsg(AddressOf Show2)

        Console.ReadLine()
    End Sub

End Module
