﻿Public Class Tree(Of TreeType)
    Public Value As TreeType
    Public Parent As Tree(Of TreeType)
    Public Tag As Object
    Public Nodes As New LinkedList(Of Tree(Of TreeType))

    Function AddNode(ByVal Node As Tree(Of TreeType),ByVal Pos As Integer) As Tree(Of TreeType)
        Node.Parent = Me
        Nodes.Insert(Node, Pos)
        Return Node
    End Function

    Function AddNode(ByVal Node As Tree(Of TreeType)) As Tree(Of TreeType)
        Node.Parent = Me
        Nodes.Add(Node)
        Return Node
    End Function

    Function AddNode(ByVal Node As TreeType, ByVal Pos As Integer) As Tree(Of TreeType)
        Dim NewTree As New Tree(Of TreeType)
        NewTree.Value = Node
        Return AddNode(NewTree, Pos)
    End Function
    
    Function AddNode(ByVal Node As TreeType) As Tree(Of TreeType)
        Dim NewTree As New Tree(Of TreeType)
        NewTree.Value = Node
        Return AddNode(NewTree)
    End Function

End Class
