﻿Public MustInherit Class TextReader
    Sub New()
        MyBase.New()
    End Sub

    Dim pNewLine As String = vbCrLf
    Public Property NewLine() As String
        Get
            Return pNewLine
        End Get
        Set(ByVal value As String)
            pNewLine = value
        End Set
    End Property

    Public MustOverride Sub Close()
    Public MustOverride Function ReadChar() As Char
    Public MustOverride Function ReadString(ByVal Count As Integer) As String

    Public Function ReadLine() As String
        Dim L As Integer = Len(NewLine)
        Dim X As String
        Dim Line As String = ReadString(L)
        ' لو كان أول ما نقرؤه هو علامة نهاية السطر
        ' فسنتجاهلها لنقرأ من بداية السطر التالي
        If X <> NewLine Then Line += X
        Do
            X = ReadString(L)
            If X = "" OrElse X = NewLine Then Exit Do
            Line += X
        Loop
        Return Line
    End Function


    Public Function ReadToEnd() As String
        Return ReadString(Length - Position)
    End Function

    Public Sub ReadNumbers(ByRef Num As Byte)
        Num = Asc(ReadChar())
        Position += 1
    End Sub

    Public Sub ReadNumbers(ByRef Num As Integer)
        Dim X As String = ReadString(4)
        Dim B() As Byte = System.Text.Encoding.ASCII.GetBytes(X)
        Num = BitConverter.ToInt32(B, 0)
    End Sub

    Enum SeekOrigin
        Begin = 0
        Current = 1
        [End] = 2
    End Enum

    Public MustOverride Function Seek(ByVal St As Long, Optional ByVal origin As SeekOrigin = SeekOrigin.Current) As Long
    Public MustOverride ReadOnly Property Length() As Long
    Public MustOverride Property Position() As Long
End Class
