﻿Structure Test : Implements IContent
    Dim B As Byte, S As Short, I As Integer
    <VBFixedArray(4)> Dim N() As Byte
    <VBFixedString(27)> Dim X As String

    Public Function GetBytes() As Byte() Implements IContent.GetBytes
        Dim L As New LinkedList(Of Byte)
        L.Add(B)
        L.AddArray(N)
        L.AddArray(BitConverter.GetBytes(S))
        L.AddArray(BitConverter.GetBytes(I))
        L.AddArray(System.Text.Encoding.Default.GetBytes(X))
        Return L.ToArray
    End Function

    Public Sub LoadBytes(ByVal B() As Byte) Implements IContent.LoadBytes
        Me.B = B(0) : ReDim N(4)
        For C As Integer = 1 To 5
            N(C - 1) = B(C)
        Next
        S = BitConverter.ToInt16(B, 6)
        I = BitConverter.ToInt32(B, 8)
        X = System.Text.Encoding.Default.GetString(B, 12, 27)
    End Sub
End Structure
