﻿Module Module1

    Sub Main()
        Dim X As String = "5"
        Dim Y As Integer = Val(X) + 3
        Console.WriteLine(Y) ' 8

        X = ""
        Y = Val(X) + 3
        Console.WriteLine(Y) ' 3

        X = "Ahmsd"
        Y = Val(X) + 3
        Console.WriteLine(Y) ' 68

        Dim I As Integer = 5
        Dim Z As String = "A" & Str(I)
        Console.WriteLine(Z) ' A 5

        Console.WriteLine(Len("Mohammad")) ' 8

        X = "ABC"
        Z = LCase(X)
        Console.WriteLine(Z) ' abc

        Console.WriteLine(UCase("abc")) ' ABC

        Console.WriteLine(StrReverse("Ali")) ' ilA

        X = "Hany"
        Z = "Ahmad"
        Select Case StrComp(X, Z)
            Case 0
                Console.WriteLine(X & " = " & Z)
            Case 1
                Console.WriteLine(Z & " comes first")
            Case Else
                Console.WriteLine(X & " comes first")
        End Select

        Console.WriteLine("A" + LTrim("  B  ") + "C") ' AB  C 
        Console.WriteLine("A" + RTrim("  B  ") + "C") ' A  BC 
        Console.WriteLine("A" + Trim("  B  ") + "C") ' ABC 

        Dim S1 As String = "ABCDE"
        Console.WriteLine(S1 + ".")
        Dim S2 As String = "DE"
        S2 = LSet(S2, Len(S1))
        Console.WriteLine(S2 + ".")

        S1 = "ABCDE"
        Console.WriteLine(S1)
        S2 = "DE"
        Console.WriteLine(RSet(S2, Len(S1)))

        X = StrDup(12, "*")
        Console.WriteLine(X) ' ************

        X = Left("Mohammad", 2)
        Console.WriteLine(X) ' Mo

        X = Right("Mohammad", 2)
        Console.WriteLine(X) ' ad

        Console.WriteLine(Mid("Mohammad", 2, 3)) ' oha
        Dim Name As String = "Mohammad"
        Mid(Name, 2, 3) = "---"
        Console.WriteLine(Name) ' M---mmad

        Name = "Mohammad"
        Name = Mid(Name, 1, 1) + "age" + Mid(Name, 8, 1)
        Console.WriteLine(Name) ' Maged

        X = "ACBABC"
        Console.WriteLine(InStr(X, "A")) '1
        Console.WriteLine(InStrRev(X, "A")) ' 4

        Dim Names() As String = {"Ali", "Fekry", "Zaher", "Sameh", "Sherif"}
        Dim N() As String = Filter(Names, "a")
        For I = 0 To UBound(N)
            Console.WriteLine(N(I))
        Next
        Console.WriteLine("***************")
        N = Filter(Names, "a", , CompareMethod.Text)
        For I = 0 To UBound(N)
            Console.WriteLine(N(I))
        Next
        Console.WriteLine("***************")
        N = Filter(Names, "a", False, CompareMethod.Text)
        For I = 0 To UBound(N)
            Console.WriteLine(N(I))
        Next
        Console.WriteLine("***************")
        N = Filter(Names, "a", False)
        For I = 0 To UBound(N)
            Console.WriteLine(N(I))
        Next
        Console.WriteLine("***************")
        X = "a man walks alone."
        X = Replace(X, "a", "A")
        Console.WriteLine(X) ' A mAn wAlks Alone.

        X = "a man walks alone."
        X = Replace(X, "a", "A", 2, 2)
        Console.WriteLine(X) '  mAn wAlks alone.

        X = "A man walks alone."
        X = Replace(X, "a", "zz", , , CompareMethod.Text)
        Console.WriteLine(X) ' zz mzzn wzzlks zzlone.

        X = "A B C D."
        X = Replace(X, " ", "")
        Console.WriteLine(X) ' ABDC.

        Dim S() As String = {"a", "b", "c"}
        X = Join(S, ", ")
        Console.WriteLine(X) ' a, b, c

        S = Split(X, ", ")
        For I = 0 To UBound(S)
            Console.WriteLine(S(I))
        Next

        Z = "i like visual basic"
        X = StrConv(Z, VbStrConv.ProperCase)
        Console.WriteLine(X)


        Console.WriteLine("Enter a number")
        X = Console.ReadLine()
        If IsNumeric(X) Then
            Y = Val(X) + 3
            Console.WriteLine(Y)
        Else
            Console.WriteLine("This is not a number")
        End If

        Console.WriteLine("ENTER YOUR NAME")
        X = Console.ReadLine()
        If InStr(1, X, "Ahmad", CompareMethod.Text) > 0 Then
            Console.WriteLine("YOU ARE THE ONE!")
        Else
            Console.WriteLine("SORRY!")
        End If


        Console.ReadLine()
    End Sub

End Module
