﻿Module Module1

    Structure Clock
        Event Ring(ByVal Time As Date)

        ReadOnly Property Time() As Date
            Get
                Return Now
            End Get
        End Property

        Private pRingTime As Date
        Property RingTime() As Date
            Get
                Return pRingTime
            End Get
            Set(ByVal value As Date)
                pRingTime = value
            End Set
        End Property

        Private pEnabled As Boolean
        Property Enabled() As Boolean
            Get
                Return pEnabled
            End Get
            Set(ByVal value As Boolean)
                pEnabled = value
                If pEnabled Then Start()
            End Set
        End Property
        
        Sub Start()
            pEnabled = True
            Do
                If DateDiff(DateInterval.Second, pRingTime, Now) = 0 Then
                    RaiseEvent Ring(Now)
                    pEnabled = False
                    Exit Sub
                End If
                ' إيقاف المنبه إذا طلب المستخدم ذلك
                If Console.KeyAvailable OrElse pEnabled = False Then
                    pEnabled = False
                    Exit Sub
                End If
            Loop
        End Sub
        Sub [Stop]()
            pEnabled = False
        End Sub
    End Structure
    

    Sub Main()
        Dim Clc As Clock
        Clc.RingTime = DateAdd(DateInterval.Second, 5, Now)
        AddHandler Clc.Ring, AddressOf Clock_Ring
        Clc.Start()
    End Sub

    Sub Clock_Ring(ByVal Time As Date)
        Console.WriteLine("It Is " + Time + " Press Any Key To Stop")
        Do
            Beep()
            If Console.KeyAvailable Then Exit Sub
        Loop
    End Sub

End Module
