﻿Module BSTApplications
    Sub AddToBST(ByRef T As Tree, ByRef Item As String)
        If T Is Nothing Then
            T = New Tree
            T.Value = Item
            Return
        End If

        If Item < T.Value Then
            If T.Left Is Nothing Then
                T.Add(Item, Tree.TreeLocation.LeftTree)
                Return
            Else ' ابحث في الفرع الأيسر عن موضع مناسب لهذا العنصر
                AddToBST(T.Left, Item)
            End If
        ElseIf T.Right Is Nothing Then
            T.Add(Item, tree.TreeLocation.RightTree)
            Return
        Else ' ابحث في الفرع الأيمن عن موضع مناسب لهذا العنصر
            AddToBST(T.Right, Item)
        End If
    End Sub

    Function GetSortedBSTArray(ByRef T As Tree) As String()
        Dim L As New LinkedList(Of String)
        ReadTree(T, L)
        Return L.ToArray
    End Function

    Sub ReadTree(ByRef T As Tree, ByRef L As LinkedList(Of String))
        If T Is Nothing Then Return
        ReadTree(T.Left, L)
        L.Add(T.Value)
        ReadTree(T.Right, L)
    End Sub

End Module
