﻿Module DirWithTree

    Sub DirTree(ByRef T As Tree(Of String), ByVal Path As String)
        Dim Dirs() As String = GetDirs(Path)
        For I As Integer = 0 To UBound(Dirs)
            T.AddNode(Dirs(I))
            DirTree(T.Nodes(I), Dirs(I))
        Next
    End Sub

    Function GetDirs(ByVal Path As String, Optional ByVal Attr As FileAttribute = -1) As String()
        Path = Replace(Path, "/", "\")
        If Not Path Like "*\" Then Path += "\"

        If Attr = -1 Then ' لم يرسل المستخدم المعامل الثاني 
            ' السمة الوحيدة التي نريدها هي أن يكون هذا العنصر مجلدا
            Attr = vbDirectory
        Else ' سنضيف سمة المجلد إلى السمات المطلوبة
            Attr = Attr Or vbDirectory
        End If

        Dim L As Integer = 255
        Dim Dirs(L) As String
        Dim C As Integer = -1

        Dim DirName As String = Dir(Path, vbDirectory)
        While DirName <> ""
            ' يجب تكوين المسار الكامل
            DirName = Path + DirName
            If (GetAttr(DirName) And Attr) = Attr Then
                C += 1
                If C > L Then
                    L += 255
                    ReDim Preserve Dirs(L)
                End If
                Dirs(C) = DirName
            End If
            DirName = Dir()
        End While
        ReDim Preserve Dirs(C)
        Return Dirs
    End Function

End Module
