﻿
Public Class Tree(Of TreeType As IComparable)

    Public Value As TreeType
    Public Left, Right As Tree(Of TreeType)

    Public Enum TreeLocation
        LeftTree = 0
        RightTree = 1
    End Enum

    Public Sub New()
        MyBase.New()
    End Sub

    Public Function Add(ByVal Value As TreeType, ByVal Location As TreeLocation) As Tree(Of TreeType)
        Dim T As New Tree(Of TreeType)
        T.Value = Value
        If Location = TreeLocation.LeftTree Then
            Left = T
        Else
            Right = T
        End If
        Return T
    End Function

End Class
