﻿Class Calculator
    Overridable Function Divide(ByVal x As Integer, ByVal y As Integer) As Double
        Return x / y
    End Function

    Overridable Function Divide(ByVal X As Double, _
               ByVal Y As Double, ByVal Z As Integer) As Double
        Return MyClass.Divide(Divide(X, Y), Z)
    End Function

End Class

Class CalculatorEx : Inherits Calculator
    Shadows Function Divide(ByVal x As Integer, ByVal y As Integer) As Double
        Dim Ex As String = "لا تمكن القسمة على صفر"
        If Y = 0 Then Throw New Exception(Ex)
        Return X / Y
    End Function
End Class

Class CalculatorEx2 : Inherits Calculator
    Overloads Function Divide(ByVal X As Integer, ByVal Y As Integer, ByVal Z As Integer) As Double
        Dim Ex As String = "لا تمكن القسمة على صفر"
        If Y = 0 OrElse Z = 0 Then Throw (New Exception(Ex))
        Return X / Y / Z
    End Function
End Class

Class CalculatorEx3 : Inherits Calculator
    Overrides Function Divide(ByVal X As Integer, ByVal Y As Integer) As Double
        Dim Ex As String = "لا تمكن القسمة على صفر"
        If Y = 0 Then Throw (New Exception(Ex))
        Return X / Y
    End Function
End Class

Class CalculatorEx4
    Inherits Calculator
    Overrides Function Divide(ByVal X As Integer, ByVal Y As Integer) As Double
        Dim Ex As String = "لا تمكن القسمة على صفر"
        If Y = 0 Then Throw (New Exception(Ex))
        Return MyBase.Divide(X, Y)
    End Function
End Class

Class CalculatorEx5 : Inherits Calculator
    Overrides Function Divide(ByVal X As Integer, ByVal Y As Integer) As Double
        Dim Ex As String = "لا تمكن القسمة على صفر"
        If Y = 0 Then Throw (New Exception(Ex))
        Return X / Y
    End Function
End Class

Class CalculatorEx6
    Inherits Calculator
    Overloads Overrides Function Divide(ByVal X As Integer, ByVal Y As Integer) As Double
        Dim Ex As String = "لا تمكن القسمة على صفر"
        If Y = 0 Then Throw (New Exception(Ex))
        Return X / Y
    End Function
End Class

Class CalculatorEx7 : Inherits Calculator
    NotOverridable Overrides Function Divide(ByVal X As _
                   Integer, ByVal Y As Integer) As Double
        Dim Ex As String = "لا تمكن القسمة على صفر"
        If Y = 0 Then Throw (New Exception(Ex))
        Return X / Y
    End Function
End Class

Class Calculator8 : Inherits CalculatorEx
    'هذا غير مسموح به
    'Overrides Function Divide(ByVal X As Integer, ByVal Y _
    'As Integer) As Double

    'End Function
End Class
