﻿Class Student : Implements IComparable
    Public Property Name As String
    Public Property Age As Integer
    Public Property Grage As Integer

    Sub New()
        MyBase.New()
    End Sub

    Sub New(ByVal Age As Integer)
        Me.Age = Age
    End Sub

    Sub New(ByVal Name As String, ByVal Age As Integer, ByVal Grade As Integer)
        Me.Name = Name
        Me.Age = Age
        Me.Grage = Grade
    End Sub

    Function CompareTo(ByVal Std As Object) As Integer _
                    Implements IComparable.CompareTo
        If Not TypeOf Std Is Student Then Throw New Exception()
        Select Case CType(Std, Student).Age
            Case Is > Me.Age
                Return -1
            Case Is < Me.Age
                Return 1
            Case Else
                Return 0
        End Select
    End Function
End Class
