﻿
Structure UserData : Implements IContent
    Const MaxUL = 20
    Const MaxPL = 6

    <VBFixedString(MaxUL)> Dim UserName As String
    <VBFixedString(MaxPL)> Dim Password As String

    Public Function GetBytes() As Byte() Implements IContent.GetBytes
        Dim S As String
        If Len(UserName) < MaxUL Then
            S = UserName + Space(MaxUL - Len(UserName))
        Else
            S = Left(UserName, MaxUL)
        End If
        If Len(Password) < MaxPL Then
            S += Password + Space(MaxPL - Len(Password))
        Else
            S += Left(Password, MaxPL)
        End If

        Return System.Text.Encoding.Default.GetBytes(S)
    End Function

    Public Sub LoadBytes(ByVal B() As Byte) Implements IContent.LoadBytes
        UserName = System.Text.Encoding.Default.GetString(B, 0, MaxUL)
        Password = System.Text.Encoding.Default.GetString(B, MaxUL, MaxPL)
    End Sub
End Structure