﻿Module RLE
    Function Compress(ByRef S As String) As String
        Dim CurChr As String = GetChar(S, 1)
        Dim Result, NextChr As String
        Dim N As Integer = 1
        For I As Integer = 2 To Len(S)
            NextChr = GetChar(S, I)
            If N < 255 AndAlso NextChr = CurChr Then
                N += 1
            Else
                Result += Chr(N) + CurChr
                CurChr = NextChr : N = 1
            End If
        Next
        Result += Chr(N) + CurChr : Return Result
    End Function

    Sub Compress(ByVal InputFile As String, ByVal OutPutFile As String)
        Dim InFs As New FileStream(InputFile)
        Dim OutFs As New FileStream(OutPutFile)
        Dim CurByte As Byte = InFs.ReadByte()
        Dim NextByte As Byte, I As Integer, N As Integer = 1
        Do
            I = InFs.ReadByte()
            If I = -1 Then Exit Do
            NextByte = CByte(I)
            If N < 255 AndAlso NextByte = CurByte Then
                N += 1
            Else
                OutFs.WriteByte(N)
                OutFs.WriteByte(CurByte)
                CurByte = NextByte : N = 1
            End If
        Loop
        OutFs.WriteByte(N)
        OutFs.WriteByte(CurByte)
        InFs.Close()
        OutFs.Close()
    End Sub

    Function Decompress(ByRef S As String) As String
        If Len(S) Mod 2 <> 0 Then
            Throw New Exception("يجب أن يكون طول النص زوجيا")
        End If
        Dim Result As String = ""
        For I As Integer = 1 To Len(S) Step 2
            Result += StrDup(ASC(Mid(S, I, 1)), Mid(S, I + 1, 1))
        Next
        Return Result
    End Function

    Sub Decompress(ByVal InputFile As String, ByVal OutPutFile As String)
        Dim InFs As New FileStream(InputFile)
        Dim OutFs As New FileStream(OutPutFile)
        Dim B, N As Byte, I As Integer
        Do
            I = InFs.ReadByte() ' قراءة عدد مرات التكرار
            If I = -1 Then Exit Do
            N = CByte(I)
            I = InFs.ReadByte() ' قراءة الوحدة التي سيتم تكرارها
            If I = -1 Then Exit Do
            B = I
            ' تكرار كتابة الوحدة تبعا لعدد مرات التكرار
            For I = 1 To N
                OutFs.WriteByte(B)
            Next
        Loop
        InFs.Close()
        OutFs.Close()
    End Sub

End Module
