﻿Public Class Form1
    ' تعريف دالة رسم منطقة منحنية
    Private Declare Function CreateEllipticRgn Lib _
         "gdi32.dll" (ByVal X1 As Integer, ByVal Y1 As Integer, _
           ByVal X2 As Integer, ByVal Y2 As Integer) As Integer
    ' تعريف دالة رسم منطقة مستطيلة
    Private Declare Function CreateRectRgn Lib "gdi32.dll" _
                 (ByVal X1 As Integer, ByVal Y1 As Integer, _
                 ByVal X2 As Integer, ByVal Y2 As Integer) As Integer
    ' تعريف دالة جمع منطقتين
    Private Declare Function CombineRgn Lib "gdi32.dll" _
            (ByVal hDestRgn As Integer, ByVal hSrcRgn1 As _
            Integer, ByVal hSrcRgn2 As Integer, ByVal _
            nCombineMode As Integer) As Integer
    ' تعريف دالة تعريف منطقة النموذج
    Private Declare Function SetWindowRgn Lib "user32" _
                  (ByVal hWnd As Integer, ByVal hRgn As Integer, _
                   ByVal bRedraw As Boolean) As Integer
    ' رسم منطقة النموذج في حدث تحميل النموذج
    Private Sub Form1_Load(ByVal sender As System.Object, _
                  ByVal e As System.EventArgs) Handles MyBase.Load
        Dim HRgn1 As Long, HRgn2 As Long
        Dim HCombineRgn As Long
        ' رسم منطقة منحنية داخل المستطيل 
        ' الذي رأساه المتقابلان (50، 50) و (500، 400)
        HRgn1 = CreateEllipticRgn(50, 50, 500, 400)
        ' رسم المستطيل الذي رأساه المتقابلان (50، 150) و (500، 300)
        HRgn2 = CreateRectRgn(50, 150, 500, 300)
        ' تعريف منطقة جديدة مساحتها صفر، لوضع الاتحاد فيها
        HCombineRgn = CreateRectRgn(0, 0, 0, 0)
        ' جمع المنطقتين معا ووضع الناتج في المنطقة الجديدة
        CombineRgn(HCombineRgn, HRgn1, HRgn2, 2)
        ' جعل المنطقة الجديدة هي مساحة النموذج
        SetWindowRgn(Me.Handle.ToInt32, HCombineRgn, True)
    End Sub
End Class
